<template>
  <div class="contenedor">
    <div :id="this.objetoParametro.id_name"></div>
  </div>
</template>

<script>
import store from "@/store";
const periodoSupervisionMtto = store.state.periodoSupervisionMtto;
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";

export default {
  name: "GraficaCircular",
  props: {
    objetoParametro: Object,
  },
  data() {
    return {
      periodo: {},
      chart: null,
    };
  },
  methods: {
    initChartG() {
      const self = this;
      am4core.useTheme(am4themes_animated);
      // Create chart instance

      var chart = am4core.create(this.objetoParametro.id_name, am4charts.RadarChart);
      chart.logo.hidden = true;
      // Add data
      chart.data = [
        {
          category: "",
          value: this.objetoParametro.value,
          full: this.objetoParametro.programadasAlTrimestre,
          full2: this.objetoParametro.programadasAlDia,
        },
      ];

      // Make chart not full circle
      chart.startAngle = 0;
      chart.endAngle = 360;

      chart.innerRadius = am4core.percent(80);

      // Create axes
      var categoryAxis = chart.yAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "category";
      categoryAxis.renderer.grid.template.location = 100;
      categoryAxis.renderer.grid.template.strokeOpacity = 0;
      categoryAxis.renderer.labels.template.horizontalCenter = "right";
      categoryAxis.renderer.labels.template.fontWeight = 20;
      categoryAxis.renderer.labels.template.adapter.add("fill", function (fill, target) {
        return target.dataItem.index >= 0
          ? chart.colors.getIndex(target.dataItem.index)
          : fill;
      });
      categoryAxis.renderer.minGridDistance = 300;
      let porcentajeAlDia = Math.round(
        (this.objetoParametro.value * 100) / this.objetoParametro.programadasAlDia
      );
      if (isNaN(porcentajeAlDia)) porcentajeAlDia = 0;
      var label = chart.createChild(am4core.Label);
      label.text = this.objetoParametro.value;
      label.text = porcentajeAlDia + "%";
      label.fontSize = 20;
      label.align = "center";
      label.isMeasured = false;
      label.x = am4core.percent(50);
      label.y = am4core.percent(30);
      label.horizontalCenter = "middle";
      label.fontWeight = "bolder";

      var label1 = chart.createChild(am4core.Label);
      label1.text = this.objetoParametro.texto;
      label1.fontSize = 9;
      label1.align = "center";
      label1.isMeasured = false;
      label1.x = am4core.percent(50);
      label1.y = am4core.percent(50);
      label1.horizontalCenter = "middle";
      label1.fontWeight = "bolder";

      var valueAxis = chart.xAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.grid.template.strokeOpacity = 0;
      valueAxis.min = 0;
      valueAxis.max = this.objetoParametro.programadasAlDia;
      valueAxis.strictMinMax = true;
      valueAxis.hidden = true;

      // Create series
      var series1 = chart.series.push(new am4charts.RadarColumnSeries());
      series1.dataFields.valueX = "full";
      series1.dataFields.categoryY = "category";
      series1.clustered = false;
      series1.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series1.columns.template.fillOpacity = 0.08;
      series1.columns.template.cornerRadiusTopLeft = 20;
      series1.columns.template.strokeWidth = 0;
      series1.columns.template.radarColumn.cornerRadius = 20;

      var series2 = chart.series.push(new am4charts.RadarColumnSeries());
      series2.dataFields.valueX = "value";
      series2.dataFields.categoryY = "category";
      series2.clustered = false;
      series2.columns.template.strokeWidth = 0;
      series2.columns.template.radarColumn.cornerRadius = 20;

      /*
            var porcentaje = this.value *100 / this.valueTotal;
            for (var i = 0; i < this.rangos.length; ++i) {
                if(porcentaje<=this.rangos[i]) {
                    this.color = this.rango_color[i];
                    break;
                }
            }
*/
      let color = "#ffcd00";
      for (var i = 0; i < this.objetoParametro.rangos.length; ++i) {
        let rangoSuperior = this.objetoParametro.rangos[i].split(",")[1];
        let rangoInferior = this.objetoParametro.rangos[i].split(",")[0];

        if (rangoSuperior >= porcentajeAlDia && porcentajeAlDia >= rangoInferior) {
          color = this.objetoParametro.colores[i];
        }
      }
      series2.columns.template.adapter.add("fill", function (fill, target) {
        return am4core.color(color);
        //return am4core.color(self.color);
      });

      this.chart = chart;
    },

    setValores() {
      this.initChartG();
    },
  },
  mounted() {
    this.setValores();
  },
  created() {
    this.periodo = periodoSupervisionMtto;
  },
  updated() {
    this.setValores();
  },
  beforeDestroy() {
    if (this.chart != null) {
      this.chart.dispose();
    }
  },
};
</script>
<style></style>
